qrun(8B)

NAME
qrun - run a PBS batch job now

SYNOPSIS
qrun [-a] [-H <vnode specification>] <job ID> [<job ID> ...]
qrun [-a] [-H - ] <job ID> [<job ID> ...]
qrun --version

DESCRIPTION
Forces a job to run, regardless of scheduling position or resource requirements. The qrun command can be used on jobs, subjobs, or ranges of subjobs, but not on job arrays. When it is used on a range of subjobs, the non-running subjobs in that range are run. When preemption is enabled, the scheduler preempts other jobs in order to run this job. Running a job via qrun gives the job higher preemption priority than any of the priorities defined in the preempt_prio scheduler parameter. Required Privilege
In order to execute qrun, you must have PBS Operator or Manager privilege. Caveats for qrun
    The job is run without respect for limits, primetime, or dedicated time. If you use a -H vnode_specification option to run a job, but specify insufficient vnodes or resources, the job may not run correctly. Avoid using this option unless you are sure. If you don't use the -H option, the job must be in the Queued state and reside in an execution queue. If you do use the -H option, the job must be in the Queued or Suspended state and reside in an execution queue. If you use the -H option, all schedulers are bypassed, and partition boundaries are ignored. The qrun command cannot be used on a job that is in the process of provisioning.

OPTIONS

-a  The qrun command exits before the job actually starts execution.

(no -H option)
    The job is run immediately regardless of scheduling policy as long as the following are true:
    The queue in which the job resides is an execution queue. Either the resources required by the job are available, or preemption is enabled and the required resources can be made available by preempting jobs that are running.

(with -H option)
    Do NOT use this option unless you know exactly what you are doing. With the -H option, all scheduling policies are bypassed and the job is run directly. The job is run immediately on the named or previously assigned vnodes, regardless of current usage on those vnodes or which scheduler manages the vnodes, with the exception of vnode state. The job is not run and the qrun request is rejected if any named vnode is down, already allocated exclusively, or would need to be allocated exclusively and another job is already running on the vnode. The job is run if the vnode is offline. The -H option runs jobs that are queued or suspended. If the qrun -H command is used on a job that requests an AOE, and that AOE is not instantiated on those vnodes, the vnodes are provisioned with the AOE. If the job requests an AOE, and that AOE is not available on the specified vnodes, the job is held.

    -H <vnode specification without resources>
        The vnode specification without resources has this format:
        (<vchunk>)[+(<vchunk>) ...]
        where vchunk has the format
        <vnode name>[+<vnode name> ...]
        Example: -H (VnodeA+VnodeB)+(VnodeC) PBS applies one requested chunk from the job's selection directive in round-robin fashion to each vchunk in the list. Each vchunk must be sufficient to run the job's corresponding chunk, otherwise the job may not execute correctly.

    -H <vnode specification with resources>
        The vnode specification with resources has this format:
        (<vchunk>)[+(<vchunk>) ...]
        where vchunk has the format

        <vnode name>:<vnode resources>[+<vnode name>:<vnode resources> ...]

        and where vnode resources has the format
            <resource name>=<value>[:<resource name>=<value> ...]

        Example:
            -H (VnodeA:mem=100kb:ncpus=1)+ (VnodeB:mem=100kb:ncpus=2+ VnodeC:mem=100kb)

        PBS creates a new selection directive from the vnode specification with resources, using it instead of the original specification from the user. Any single resource specification results in the job's original selection directive being ignored. Each vchunk must be sufficient to run the job's corresponding chunk, otherwise the job may not execute correctly. If the job being run requests -l place=exclhost, take extra care to satisfy the exclhost request. Make sure that if any vnodes are from a multi-vnoded host, all vnodes from that host are allocated. Otherwise those vnodes can be allocated to other jobs.

    -H -
        Runs the job on the set of resources to which it is already assigned. You can run a job on the set of resources already assigned to the juob, without having to list the resources, by using the - (dash) argument to the -H option.

--version
    The qrun command returns its PBS version information and exits. This option can only be used alone.

OPERANDS

Job ID
    The qrun command accepts a list of job IDs, of the form <sequence number>[.<server name>][@<server name>]
    <sequence number>[<index>][.<server name>][@<server name>]

    <sequence number>[<index start>-<index end>][.<server name>][@<server name>]

    Note that some shells require that you enclose a job array identifier in double quotes.

vnode specification
    The vnode specification without resources has this format:

    (<vchunk>)[+(<vchunk>) ...]
    where vchunk has the format
    <vnode name>[+<vnode name> ...]
    Example: -H (VnodeA+VnodeB)+(VnodeC)

    The vnode specification with resources has this format:

    (<vchunk>)[+(<vchunk>) ...]
    where vchunk has the format
    <vnode name>:<vnode resources>[+<vnode name>:<vnode resources> ...]
    and where vnode resources has the format
    <resource name>=<value>[:<resource name>=<value> ...] Example: -H (VnodeA:mem=100kb:ncpus=1) + (VnodeB:mem=100kb:ncpus=2 + VnodeC:mem=100kb)

    A vnode name is the name of the vnode, not the name of the host.

STANDARD ERROR
The qrun command writes a diagnostic message to standard error for each error occurrence.

EXIT STATUS

Zero
    On success

Greater than zero
    If the qrun command fails to process any operand

SEE ALSO
The PBS Professional Administrator's Guide,
qsub(1B), qmgr(8B), pbs_runjob(3B)